use std::process;

use golgi::error::GolgiError;
use golgi::messages::SsbMessageContent;
use golgi::sbot::Sbot;

async fn run() -> Result<(), GolgiError> {
    let mut sbot_client = Sbot::init(None, None).await?;

    let id = sbot_client.whoami().await?;
    println!("whoami: {}", id);

    let name = SsbMessageContent::About {
        about: id.clone(),
        name: Some("golgi".to_string()),
        title: None,
        branch: None,
        image: None,
        description: None,
        location: None,
        start_datetime: None,
    };

    let name_msg_ref = sbot_client.publish(name).await?;
    println!("name_msg_ref: {}", name_msg_ref);

    let post = SsbMessageContent::Post {
        text: "golgi go womp womp".to_string(),
        mentions: None,
    };

    let post_msg_ref = sbot_client.publish(post).await?;
    println!("post_msg_ref: {}", post_msg_ref);

    let post_msg_ref = sbot_client
        .publish_description("this is a description7")
        .await?;
    println!("description: {}", post_msg_ref);

    let author: String = id.clone();
    println!("author: {:?}", author);
    let description = sbot_client.get_description(&author).await?;
    println!("found description: {:?}", description);

    let post = SsbMessageContent::Post {
        text: "golgi go womp womp2".to_string(),
        mentions: None,
    };

    let post_msg_ref = sbot_client.publish(post).await?;
    println!("post_msg_ref2: {}", post_msg_ref);

    Ok(())
}

#[async_std::main]
async fn main() {
    if let Err(e) = run().await {
        eprintln!("Application error: {}", e);
        process::exit(1);
    }
}
